//----------------------------------------------------------------
//
// NeuroChip NM6403, C++ library
// 1997-1998 (c) RC Module Inc.
// _nsstd.h,
//
// an auxiliary header for dealing with namespace std
//
//----------------------------------------------------------------

#ifndef _NSSTD_H
#define _NSSTD_H


#if !defined(__cplusplus) || defined(__NO_NAMESPACES) || defined(__NO_NAMESPACE_STD)

#define _NS_STD
#define _NS_STD_BEGIN
#define _NS_STD_END
#define _USING_STD(name)

#else

#define _NS_STD std::
#define _NS_STD_BEGIN namespace std {
#define _NS_STD_END   }
#define _USING_STD(name) using std::name;

#endif


#endif  // _NSSTD_H
