//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                           div32.asm                                      //
//                                                                          //
//     32- .                                       //
//   IDiv32 -                                           //
//   UDiv32 -                                           //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2     . 
//     .

global IDiv32 :label;
global UDiv32 :label;


begin text

//=======   DivPos ========
// gr7 -  .
// gr0 - 
// gr1 -  
// gr2 -   ( ).
<DivPos>
    gr7 = gr1 - gr0;
    if u< skip Div      //   
        with gr7 - gr0;
    if u< skip Div;     //    
<Loop0>
    gr0 <<= 1;
    gr7 = gr1 - gr0;
    with gr7 - gr0;
    if u>= skip Loop0
        with gr2++;

<Div>        // 
    with gr1 - gr0;
    gr7 = false noflags;
<PDivLoop>
    if u< delayed skip L8
        with gr7 C<<= 1;
    gr2--;
    nul;
    // cond. skip L8
    gr1 -= gr0 noflags;
<L8>
    if >= delayed skip PDivLoop
        with gr0 >>= 1;
    with gr1 - gr0;
    nul;
    // cond. skip PDivLoop
    return;


//=====  UDiv32 ========
//   32- 
//    .
//  :     .
// +0 = SP    
// -1 = ,  32 
// -2 = ,  32 
// -3 = PSW
// -4 = PC
//
//  : gr7 - 
// : ar5
<UDiv32>
        //   gr5   gr7
        //   
    pop ar5,gr5 with gr7 = gr5;         // ar5 - , gr5 - 

    push ar0,gr0 with gr0 = gr5;        // gr0 - 
    push ar1,gr1 with gr5 = gr7 noflags;    // ar5 - 

    if =0 delayed skip UOver;
    push ar2, gr2;
    gr1 = ar5 with gr2 = false;         // gr1 - 
        // end of delayed if skip

    callrel DivPos;
<UOver>
    pop ar2, gr2;
    pop ar1, gr1;
    pop ar0, gr0;
    return;


//=====  IDiv32 ========
//   32- 
//    .
//  :     .
// +0 = SP    
// -1 = ,  32 
// -2 = ,  32 
// -3 = PSW
// -4 = PC
//
//  : gr7 - 
// : ar5
<IDiv32>
        //   gr5   gr7
        //   
    pop ar5,gr5 with gr7 = gr5;         // ar5 - , gr5 - 

    push ar0,gr0 with gr0 = gr5;        // gr0 - 
    push ar1, gr1 with gr5 = gr7 noflags;

    gr1 = ar5;                          // gr1 - 

    if =0 delayed skip IOver;
    push ar3, gr3 with gr3 = gr0 xor gr1;
    push ar2, gr2 with gr2 = false noflags;
        // delayed if skip IOver

    if >= skip L4 with gr1;
    gr0 = -gr0 noflags;
<L4>
    if < skip Neg;  //  

    callrel DivPos;
    with gr3;
<Res>
    if >= delayed skip L5;
<IOver>
    pop ar2, gr2;
    pop ar3, gr3;
    // cond. skip L5
    gr7 = -gr7;
<L5>
    pop ar1, gr1;
    pop ar0, gr0;
    return;

<Neg>
    gr7 = gr1 - gr0;
    if >= skip NDiv
        with gr7 - gr0;
    if > skip NDiv;
<Loop2>
    gr0 <<= 1;
    gr7 = gr1 - gr0;
    with gr7 - gr0;
    if v<= skip Loop2       // '<=' to 'v<=' changed Ch.A. for break infinite
        with gr2++;         // loop when 80000000h / 2
<NDiv>
    with gr1 - gr0;
    gr7 = false noflags;
<NDivLoop>
    if > delayed skip L1
        with gr7 <<= 1;
    gr2--;
    nul;
    // cond. skip L1
    gr1 -= gr0 noflags;
    gr7++ noflags;
<L1>
    if >= delayed skip NDivLoop
        with gr0 A>>= 1;
    with gr1 - gr0;
    nul;
    // cond. skip NDivLoop
    skip Res
        with gr3;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                         div32.asm                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

