//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                          i32tod.asm                                      //
//                                                                          //
//        32      //
//     64 .                                     //
// ConvI32toD -     double.                           //        
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 01.12.97 )
// : 
// :   2    .    
//   .    .

global ConvI32toD :label;


extern DResult :label;


begin text

//=====  ConvI32toD ==========================
//       32    
//     64 .
//  : gr7 -   
//  :     -   .
//                -  .
//   ar7 = ar7 (  ) + 2.
// : ar5, gr7
<ConvI32toD>
    push ar6,gr6;
    push ar2,gr2 with gr2 = gr7;    // gr2 - ,  
    push ar0,gr0;
    push ar5,gr5 with gr5 = false noflags;  // gr5 = 0,   

    if >= delayed skip L1;
    push ar3,gr3 with gr0 = false;  // gr0 = 0
    push ar1,gr1 with gr1 = false;  // gr1 = 0
    // cond. if skip L1;

    with gr2 = -gr2;
    with gr5 = true;
<L1>
    push ar4,gr4
        with gr4 = false;
    delayed call DResult;
    gr3 = 1023 + 20;
    // call DResult;

        //  
    pop ar4,gr4;
    pop ar1,gr1;
    pop ar3,gr3;
    pop ar5,gr5;

        //    ar5,gr5.   gr5 
        //   gr7
    ar5,gr5 = ar0, gr0 with gr7 = gr5;
    pop ar0,gr0;

    pop ar2,gr2;
    pop ar6,gr6;

        //  return    ==> 3  
    delayed return;
    push ar5,gr5 with gr5 = gr7;
    nul;
    nul;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                        i32tof.asm                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
