//    
//        
//      
//	  nmc3

begin text

.if .nm64revision == 5;

    global _LibintGetPCR : label;
    global _LibintGetPSWR : label;
    global _GetInterruptMaskIMR : label;

    global _EnableHWStackTop : label;
    global _DisableHWStackTop : label;
    global _EnableInstrCache : label;
    global _DisableInstrCache : label;


//------------------------------------------
// LibintGetPCR;
//      


    <_LibintGetPCR>
        delayed return;
        gr7 = pcr_6405;
        vnul;
        vnul;

//------------------------------------------
// LibintGetPSWR;
//      

    <_LibintGetPSWR>
        delayed return;
        gr7 = pswr_nmc3;
        vnul;
        vnul;

//------------------------------------------
// GetInterruptMaskIMR;
//    

    <_GetInterruptMaskIMR>
        delayed return;
        gr7 = imr;
        gr7 = imr;
        vnul;

//------------------------------------------
//	EnableHWStackTop, DisableHWStackTop
//     

    <_EnableHWStackTop>
        delayed return;
        vnul;
        pswr_nmc3 set 0000_1000h;

    <_DisableHWStackTop>
        delayed return;
        vnul;
        pswr_nmc3 clear 0000_1000h;

//------------------------------------------
//  EnableInstrCache, DisableInstrCache
//    

    <_EnableInstrCache>
        delayed return;
        vnul;
        pcr_6405 set 0000_0080h;

    <_DisableInstrCache>
        delayed return;
        vnul;
        pcr_6405 clear 0000_0080h;

//------------------------------------------

.endif;		//.if .nm64revision == 5;

end text;



